/*
 * linijka.c
 *
 * Created: 2011-09-03 13:17:25
 *  Author: Dominik
 */ 

#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
//definicje zaczenia niektrych ukadw did
#define ZGAS PORTD &= ~(1<<PD5 | 1<<PD4 | 1<<PD3 | 1<<PD1 | 1<<PD0);PORTA &= ~(1<<PA0 | 1<<PA1)  //gasi wszystko
#define JEDEN PORTA |= (1<<PA0)
#define DWA PORTD |= (1<<PD1) | (1<<PD4)
#define CZTERY PORTD |= (1<<PD0) | (1<<PD1) | (1<<PD4) | (1<<PD5)
#define DWA1 PORTD |= (1<<PD3);PORTA |= (1<<PA1)
#define PRZYCISK (!(PIND & (1<<PD2)))
int main(void)
{
	ACSR |= (1<<ACD);//wyczenie przetwornika analogowego
	//wyczanie watchdoga
	MCUSR &= ~(1<<WDRF);
	WDTCSR |= (1<<WDCE) | (1<<WDE);
	WDTCSR = 0;
	//konfiguracja portw
	DDRB = (1<<PB3) | (1<<PB4);
	DDRD = (1<<PD5) | (1<<PD4) | (1<<PD3) | (1<<PD1) | (1<<PD0);
	DDRA = (1<<PA0) | (1<<PA1);
	PORTD |= (1<<PD2) | (1<<PD6);
	PORTB = (1<<PB0) | (1<<PB1) | (1<<PB2) | (1<<PB5) | (1<<PB6) | (1<<PB7);
	uint8_t losowanie = 0;
	int spij = 0;//zmienna okrelajca czas zanicia
	GIMSK |= (1<<INT0);//odblokowanie przerwania INT0
	
    while(1)
    {
		if(PRZYCISK){ //jeeli przycisk nacinity
			spij = 0;//zerowanie licznika zanicia
			ZGAS;
			while(PRZYCISK){
				losowanie++;
			}
			for(uint8_t i = 0;i<6;i++){//Ptla odpowiedzialna za animacj diod i pukanie membrany
				ZGAS;
				switch(i){
					case 0:
					PORTD |= (1<<PD5);
					break;
					case 1:
					PORTD |= (1<<PD3);
					break;
					case 2:
					PORTD |= (1<<PD1);
					break;
					case 3:
					PORTD |= (1<<PD0);
					break;
					case 4:
					PORTA |= (1<<PA1);
					break;
					case 5:
					PORTD |= (1<<PD4);
					break;
				}
				for(uint8_t j = 0;j<4;j++){
					PORTB |= (1<<PB3);PORTB &= ~(1<<PB4);//pukanie membrany
					_delay_ms(4);
					PORTB |= (1<<PB4);PORTB &= ~(1<<PB3);
					_delay_ms(4);
				}
				_delay_ms(100);
			}
			PORTB &= ~(1<<PB4 | 1<<PB3);
			ZGAS;
			switch(losowanie % 6){//wywietla odpowiedni kombinacj w zalenoci od wylosowanego wyniku
				case 0:
				JEDEN;
				break;
				case 1:
				DWA;
				break;
				case 2:
				JEDEN;DWA;
				break;
				case 3:
				CZTERY;
				break;
				case 4:
				CZTERY;JEDEN;
				break;
				case 5:
				CZTERY;DWA1;
				break; 
			}
			_delay_ms(100);		
		}
		_delay_ms(1);
		spij++;
		if(spij > 10000){//jak mino 10s
			spij = 0;
			ZGAS;
			EIFR |= (1<<INTF0);//zeruje flag przerwania
			set_sleep_mode(SLEEP_MODE_PWR_DOWN);//ustawia tryb upienia POWER DOWN
			sei();//odblokowywuje przerwania
			sleep_mode();//zasypia
			cli();//blokuje przerwania
		}			   
    }
}
ISR(INT0_vect){}//pusta procedura (przerwanie jest generowane tylko po to aby procesor wybudzi)
